%IG20 - loha 2 (Analza deformac)
%RSC (rsc@email.cz)

clear
clc

fid = 1;
fid = fopen('ig20_u02.txt','w'); %vytvoreni *.txt souboru pro vystup

%-------------------------------------------------------------------------------
body = [ %souradnice bodu z 0.etapy
%  bod         Y [m]          X [m]    
    1       1000.0000       5054.3530  %rsc
    2       1057.3352       5061.1786                   
    3       1068.5019       5015.1803                   
    4       1043.0261       4986.4149                   
    5       1000.0000       5000.0000                   
    6       1034.9502       5031.2513     
];

data = [
%stanovisko ; cl ; smer v 0.etape ; smer v 1.etape
    1 2  28.7676  28.7785 %rsc
    1 3  69.3803  69.3960
    1 6  73.4906  73.5036
    1 4 100.3683 100.3883
    1 5 136.3105 136.3362

    2 3 110.4234 110.4220
    2 4 137.6230 137.6217
    2 6 166.4705 166.4811
    2 5 173.5228 173.5215
    2 1 218.0430 218.0347
    
    3 4  81.8232  81.8266
    3 5 121.7985 121.8009
    3 6 164.1193 164.1267
    3 1 168.7498 168.7517
    3 2 220.5172 220.5209
    
    4 5  36.5875  36.5876
    4 1  81.1768  81.1781
    4 6 105.7724 105.7664
    4 2 129.1563 129.1559
    4 3 163.2613 163.2603
    
    5 1 174.3412 174.3473
    5 2 222.2774 222.2775
    5 6 227.8945 227.8842
    5 3 260.4578 260.4570
    5 4 293.8112 293.8097
];


s0 = [%opravy smeru v 0.etape
    -2    -6     8 %s1 <--- stanovisko 1
     1   -11    10
     7   -11     5
     6   -12     6
    -1    -7     7
     2   -13    10
    
    -6     4     2 %s2
    -5     4     2
    -5    12    -7
    -4     6    -2
     4    -3    -1
     2     5    -6

     6    -9     4 %s3
     6    -5    -2
     4    -1    -3
     7     2    -8
    -7     7     0
    -7     6     1     
     
    -1     3    -2 %s4
     3    -2     0
    -3     5    -1
     4    -1    -4
     6    -6     0
    -1     4    -4
    
    -3    -2     4 %s5
     1    -7     6
     1   -12    11
    -1   -11    12
     4   -12     7
    -5     0     4
];


s1 = [%opravy smeru v 1.etape
    -7     5     3 %s1
     4   -10     7
    -4    -4     7
    -5     0     6
   -12     2     9
    -9    11    -3
    
    -7     4     3 %s2
    -8     2     6
    -6     9    -3
     1     2    -3
    -1    -7     7
    -1     6    -4    

    -9     8     1 %s3
   -10     1     9
    -3     1     3
   -12     6     7
    -3    -7     9
    -8     3     4
    
    -4     0     5 %s4
    -1    -5     7
   -10    -3    13
   -11    -1    12
    -1    -4     4
    -9     0     8    
    
     2     2    -3 %s5
     9   -12     2
     4    -7     2
    -5    -6    12
    10    -1   -10
    -1    -3     3
];

[pb,pom] = size(body);
pb = pb - 1; %pocet bodu obvodov ste (= body na kterch se merilo)
%-------------------------------------------------------------------------------

data = sortrows(data,1); %serazen meren podle stanovisek

%urcen apriorn presnosti smeru


sig_c = 10; %chyba clen
sig_o = 4;  %chyba odectn

fprintf(fid,'                                 sigma c     = %5.2f cc (chyba clen)\n',sig_c);
fprintf(fid,'                                 sigma o     = %5.2f cc (chyba odetn)\n',sig_o);
sig_fi = (sig_c^2 + sig_o^2)^0.5;
fprintf(fid,'                                 sigma fi    = %5.2f cc\n',sig_fi);

sig_fi_1 = sig_fi / 2^0.5;
fprintf(fid,'                                 sigma fi''   = %5.2f cc\n',sig_fi_1);

sig_fi_2 = sig_fi_1 / 2^0.5;
fprintf(fid,'                                 sigma fi''''  = %5.2f cc\n',sig_fi_2);

sig_fi_3 = sig_fi_2 / 3^0.5; %apriorn presnost meren
fprintf(fid,'                                 sigma fi'''''' = %5.2f cc\n',sig_fi_3);


fprintf(fid,'zkladn smrodatn odchylka rozdlu smr = %5.2f cc\n\n',2^0.5 * sig_fi_3);

DTDfi = 2 * 2^0.5 * sig_fi_3;

fprintf(fid,'                         mezn rozdl smr = %5.2f cc\n',DTDfi);


DTw = 2^0.5 * 2^0.5 * sig_fi_3 * 2;

fprintf(fid,'                          mezn rozdl hl = %5.2f cc\n',DTw);

DTDU = 2 * 12^0.5 * sig_fi_3;

fprintf(fid,'        mezn rozdl uzvru v trojuhelnku = %5.2f cc\n',DTDU);

DTU = 2 * 6^0.5 * sig_fi_3;

fprintf(fid,'                mezn uzvr v trojuhelnku = %5.2f cc\n',DTU);


%-----------------------------------------------------------------

TEST1 = zeros(pb + 1,1); %

[n_fi,pom] = size(data); %pocet smeru

Dfi = 10000 * (data(:,3) - data(:,4));
SDfiDfi = sum(Dfi.^2);


fprintf(fid,'\n\n     smery\n');
fprintf(fid,'     z na     0.etapa [g]   1.etapa [g]   rozdl [cc]\n');
fprintf(fid,'-----------------------------------------------------\n');

for i=1:n_fi
    fprintf(fid,'%2.f:  %.f  %.f     %9.4f     %9.4f      %6.1f \n',i,data(i,1:4),Dfi(i));
end

fprintf(fid,'-----------------------------------------------------\n');
fprintf(fid,'[DD]                                     %6.1f \n',SDfiDfi);

fprintf(fid,'\n\n\n\n');


n = 0; %pocet trojuhelnku (kombinacn cslo:3 C pb)
Su0u0 = 0; %Suma ctvercu uzveru 0.etapy
Su1u1 = 0; %Suma ctvercu uzveru 1.etapy
SDuDu = 0; %Suma ctvercu rozdlu uzaveru 0. a 1. etapy

fprintf(fid,'    trojuhelnk        uzver trojuhelnku\n');
fprintf(fid,'     i   j   k      0.etapa [cc]   1.etapa [cc]   rozdl [cc]\n');
fprintf(fid,'-------------------------------------------------------------\n');


for i=1:pb
    for j=i+1:pb
        for k=j+1:pb
            n = n + 1;
            
            u0 = uzaver(i,j,k,0,data);
            Su0u0 = Su0u0 + u0^2;
            
            u1 = uzaver(i,j,k,1,data);
            Su1u1 = Su1u1 + u1^2;
            
            SDuDu = SDuDu + (u0 - u1)^2;
            
            u0t = ' ';
            u1t = ' ';
            Dut = ' ';
            
            if(abs(u0) > DTU)
                u0t = '*';
            end

            if(abs(u1) > DTU)
                u1t = '*';
            end
            
            if(abs(u0 - u1) > DTDU)
                Dut = '*';
            end
            
            
            fprintf(fid,'%2.f:  %.f - %.f - %.f        %6.1f %s       %6.1f %s      %6.1f %s\n',n,i,j,k,u0,u0t,u1,u1t,u0-u1,Dut);
        end
    end
end

fprintf(fid,'-------------------------------------------------------------\n');
fprintf(fid,'[UU]                  %6.1f         %6.1f        %6.1f\n',Su0u0,Su1u1,SDuDu);


fprintf(fid,'\n\n\n\n');


fprintf(fid,'       hel          \n');
fprintf(fid,'     L Vrch. P      0.etapa [g]    1.etapa [g]   rozdl [cc]\n');
fprintf(fid,'------------------------------------------------------------\n');

n_w = 0; %pocet trpjuhelnku
SDwDw = 0; %Suma ctvercu rozdlu uhlu

for i=1:pb %vrchol = i
    for j=1:pb %lev rameno = j
        if(i ~= j)
            for(k=j+1:pb) %prav rameno = k
                if(k ~= i)
                    w0 = uhel(j,i,k,0,data);
                    w1 = uhel(j,i,k,1,data);
                    n_w = n_w + 1;
                    Dw = 10000*(w0-w1);
                    SDwDw = SDwDw + Dw^2;
                    
                    fprintf(fid,'%2.f:  %.f - %.f - %.f      %9.4f     %9.4f      %6.1f ',n_w,j,i,k,w0,w1,Dw);
                    
                    if(abs(Dw) > DTw)
                        fprintf(fid,'*');
                        
                        TEST1(i) = TEST1(i) + 1;

                    end
                        
                    fprintf(fid,'\n');
                end
            end
        end
    end
end

fprintf(fid,'------------------------------------------------------------\n');
fprintf(fid,'[DD]                                            %6.1f \n',SDwDw);

TEST1(end) = pb + 1;


fprintf(fid,'\n\npekroen meznho uzvru (pro uren nestabilnch bod (mon maximum = %i))\n',pb+1);
fprintf(fid,' bod   poet\n');
for i=1:pb
    fprintf(fid,'  %i      %i\n',i,TEST1(i));
end


fprintf(fid,'\n\n\n\n');


fprintf(fid,'s fi I\n');

if((size(s0)) == (size(s1)))
    [a,b] = size(s0);
    krok = a / pb;
    
    fprintf(fid,' stanovisko   0.etapa [cc]  1.etapa [cc]\n');
    fprintf(fid,'----------------------------------------\n');
    
    for i=1:pb
        od = i * krok - krok + 1;
        do = od + krok - 1;
        
        s_fi_I_0et = s_fi_I(s0(od:do,:));
        s_fi_I_1et = s_fi_I(s1(od:do,:));
        
        fprintf(fid,'     %.f        %6.1f        %6.1f \n',i,s_fi_I_0et,s_fi_I_1et);
    end
else
    fprintf(fid,'\n');
    fprintf(fid,'!!! rozmer matice oprav smeru v 0. a 1. etape je ruzn !!!\n');
    fprintf(fid,'!!!               s_fi_I si spoctej rucne             !!!\n');
    fprintf(fid,'\n');    
end

fprintf(fid,'\n');


s_fi_II_0et = (Su0u0 / (6 * n))^0.5;

fprintf(fid,'s fi II 0.etapa = %4.1f cc\n',s_fi_II_0et);


s_fi_II_1et = (Su1u1 / (6 * n))^0.5;

fprintf(fid,'s fi II 1.etapa = %4.1f cc\n',s_fi_II_1et);


fprintf(fid,'\n');


s_fi_III = (SDuDu / (12 * n))^0.5;

fprintf(fid,'s fi III = %4.1f cc\n',s_fi_III);


fprintf(fid,'\n');


s_fi_IV = (SDfiDfi / (2 * n_fi))^0.5;
F4 = s_fi_III^2 / s_fi_IV^2;

fprintf(fid,'s fi IV = %4.1f cc (F = %.8f)\n',s_fi_IV,F4);


fprintf(fid,'\n');


s_fi_V = (SDwDw / (4 * n_w))^0.5;

F5 = s_fi_III^2 / s_fi_V^2;

fprintf(fid,'s fi V = %4.1f cc (F = %.8f)\n',s_fi_V,F5);

fprintf(fid,'\n\n\n\n\n');

fprintf(fid,'vstup pro Geo-W: (pro sputn je zejm teba nastavit systmov datum na rok 2003)\n');

fprintf(fid,'<------------------------<>------------------------>\n');

fprintf(fid,'''IG20: Analza deformac - skupina 62/5''\n');

fprintf(fid,'%4.2f 0.00 %4.2f 0.00\n',2^0.5 * sig_fi_3,2^0.5 * sig_fi_3); %smerodatn odchylka: rozdlu hlu [cc] , rozdlu dlek [mm] , jednotkov , souradnicov [mm]

[n,pom] = size(body);

for i=1:n
    
    stabilita = 3;
    if(TEST1(i) > pb - 1)
        stabilita = 0; %urcen nestabilnch bodu
    end
    
    fprintf(fid,' %i %i %10.1f %10.1f\n',body(i,1),stabilita,1000*body(i,3),1000*body(i,2));%bod , kod , X [mm], Y [mm] (kod: 0 = nestabiln, 3 = stabiln bod)
end

fprintf(fid,'-1\n');

[n,pom] = size(data);

for i=1:n
    fprintf(fid,' %i %i %9.1f %9.1f 1.00\n',data(i,1:2),10000*data(i,3:4));%stanovisko , cl , smer v 0.etape [cc], smer v 1.etape [cc] , vha
end

fprintf(fid,'-1\n');
fprintf(fid,'-1\n');

fprintf(fid,'<------------------------<>------------------------>\n');



T0 = sum(s0')';
T1 = sum(s1')';

fprintf(1,' Kontrola zadn chyb merench smeru (rozdly od prumeru) pro vocet s fi I\n');
fprintf(1,' Nze uveden csla by mely nabvat hodnot -1,0,1 (v rmci chyby ze zaokrouhlen).\n');
fprintf(1,' Pokud je tam jin cslo (je zvrazneno sipkou  <||  ), jsou chyby v prslusnm\n');
fprintf(1,' smeru spatne spoctan nebo zapsan a je treba je opravit...\n\n');

fprintf(1,'  smery       [v]       [v]\n');
fprintf(1,'  z  na     0.etapa   1.etapa\n');
fprintf(1,'------------------------------\n');


for i=1:n
    t0 = '   ';
    t1 = '   ';
    
    if(abs(T0(i)) > 1)
        t0 = '<||';
    end

    if(abs(T1(i)) > 1)
        t1 = '<||';
    end
    
    fprintf(1,'  %i   %i       %3.0f %s   %3.0f %s \n',data(i,1:2),T0(i),t0,T1(i),t1);
end


fclose(fid);
fprintf('\n\nVsledky jsou ulozeny v souboru "ig20_u02.txt" v pracovnm adresri\n\n');